<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :lg="16" :md="16" :sm="24" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama wilayah, kode pos" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :lg="8" :md="8" :sm="24" class="text-align-right">
                    <el-button v-permission="[null, 'region', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Wilayah
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="regions" ref="regionTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Wilayah"
                width="250">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Tipe Wilayah"
                width="200">
                <template slot-scope="scope">
                    <el-tag v-if="getAdministrativeRegion(scope.row.path) == 'Provinsi'" type="primary" size="mini">{{ getAdministrativeRegion(scope.row.path) }}</el-tag>
                    <el-tag v-else-if="getAdministrativeRegion(scope.row.path) == 'Kabupaten/Kota'" type="success" size="mini">{{ getAdministrativeRegion(scope.row.path) }}</el-tag>
                    <el-tag v-else-if="getAdministrativeRegion(scope.row.path) == 'Kecamatan'" type="warning" size="mini">{{ getAdministrativeRegion(scope.row.path) }}</el-tag>
                    <el-tag v-else type="info" size="mini">{{ getAdministrativeRegion(scope.row.path) }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Wilayah Dari"
                width="250">
                <template slot-scope="scope">
                    <el-tag v-if="getAdministrativeRegion(scope.row.path) == 'Kabupaten/Kota'" type="primary" size="mini">{{ getAdministrativeRegion(scope.row.parents.path) }} {{ scope.row.parents.name }}</el-tag>
                    <el-tag v-else-if="getAdministrativeRegion(scope.row.path) == 'Kecamatan'" type="success" size="mini">{{ getAdministrativeRegion(scope.row.parents.path) }} {{ scope.row.parents.name }}</el-tag>
                    <el-tag v-else-if="getAdministrativeRegion(scope.row.path) == 'Kelurahan'" type="warning" size="mini">{{ getAdministrativeRegion(scope.row.parents.path) }}  {{ scope.row.parents.name }}</el-tag>
                    <span v-else>-</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kode Pos"
                width="100">
                <template slot-scope="scope">
                    <span v-if="scope.row.postal">{{ scope.row.postal }}</span>
                    <span v-else>-</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'region', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'region', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showFormDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="regionForm" :model="regionForm" :rules="regionRules">
                <aside>
                    <el-alert type="info" description="Modul wilayah adalah modul yang digunakan untuk manajemen daftar wilayah di Indonesia seperti provinsi, kabupaten/kota, kecamatan dan keluarahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama Wilayah" prop="name">
                    <el-input ref="name" name="name" v-model="regionForm.name" placeholder="Nama wilayah" autocomplete="off" maxlength="255" show-word-limit>
                        <template slot="prepend">{{ regionType }}</template>
                    </el-input>
                </el-form-item>

                <h3>Pilih struktur wilayah jika wilayah di atas merupakan bagian dari:</h3>
                
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item label="Provinsi" prop="province">
                            <el-select
                                ref="province"
                                name="province"
                                class="width-100"
                                v-model="regionForm.province"
                                placeholder="Pilih Provinsi"
                                :loading="provinceLoading"
                                @change="handleProvinceChange"
                                no-data-text="Provinsi tidak ditemukan">
                                <el-option
                                    v-for="item in provinces"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">                        
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item v-if="regionForm.province" label="Kab/Kota" prop="city">
                            <el-select
                                ref="city"
                                name="city"
                                class="width-100"
                                v-model="regionForm.city"
                                placeholder="Pilih Kab/Kota"
                                :loading="cityLoading"
                                @change="handleCityChange"
                                no-data-text="Kabupaten/Kota tidak ditemukan">
                                <el-option
                                    v-for="item in cities"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">    
                                    <span style="float: left">{{ item.name }}</span>
                                    <span style="float: right; color: #8492a6; font-size: 13px">{{ item.parents.name }}</span>                    
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>
                
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item v-if="regionForm.city" label="Kecamatan" prop="district">
                            <el-select
                                ref="district"
                                name="district"
                                class="width-100"
                                v-model="regionForm.district"
                                placeholder="Pilih Kecamatan"
                                :loading="districtLoading"
                                @change="handleDistrictChange"
                                no-data-text="Kecamatan tidak ditemukan">
                                <el-option
                                    v-for="item in districts"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">    
                                    <span style="float: left">{{ item.name }}</span>
                                    <span style="float: right; color: #8492a6; font-size: 13px">{{ item.parents.name }}</span>                    
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24">
                        <el-form-item v-if="regionForm.district" label="Kode Pos" prop="postal">
                            <el-input type="number" ref="postal" name="postal" v-model="regionForm.postal" placeholder="Kode pos" autocomplete="off" maxlength="10"></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>                
                
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showFormDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'region', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Region',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            provinceLoading: false,
            cityLoading: false,
            districtLoading: false,
            subdistrictLoading: false,
            filter: {
                keyword: ''
            },
            showFilterDialog: false,
            showFormDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Wilayah',
                create: 'Tambah Wilayah'
            },
            regionType: 'Provinsi',
            regionForm: {
                id: null,
                name: '',
                province: null,
                city: null,
                district: null,
                subdistrict: null,
                postal: '',
                archived: false
            },
            regionRules: {
                name: [{ 
                    required: true, message: 'Nama wilayah wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama wilayah maksimal 255 karakter', trigger: 'blur',
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                postal: [{ pattern: /^\d+$/, message: 'Hanya angka yang diperbolehkan', trigger: 'blur'}]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('region', [
            'regions',
            'pagination',
            'provinces',
            'cities',
            'districts',
            'subdistricts'
        ]),
    },
    created() {
        this.getRegions();
        this.getProvinces();
    },
    methods: {
        playSound,
        dateFormat,
        getAdministrativeRegion(path){
            path = path.split('/');
            if(path.length == 1){
                return 'Provinsi';
            }else if(path.length == 2){
                return 'Kabupaten/Kota';
            }else if(path.length == 3){
                return 'Kecamatan';
            }else{
                return 'Kelurahan';
            }
        },
        getRegions() {
            this.tableLoading = true;
            this.$store.dispatch('region/getRegions', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getProvinces() {
            this.tableLoading = true;
            this.$store.dispatch('region/getProvinces', {
                administrative: true
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getCities() {
            this.cityLoading = true;
            this.$store.dispatch('region/getCities', {
                parent: this.regionForm.province,
                administrative: true
            }).then(() => {
                this.cityLoading = false;
            });
        },
        getDistricts() {
            this.districtLoading = true;
            this.$store.dispatch('region/getDistricts', {
                parent: this.regionForm.city,
                administrative: true
            }).then(() => {
                this.districtLoading = false;
            });
        },
        getSubdistricts() {
            this.subdistrictLoading = true;
            this.$store.dispatch('region/getSubdistricts', {
                parent: this.regionForm.district,
                administrative: true
            }).then(() => {
                this.subdistrictLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('region/getRegions', {
                q: this.filter.keyword,
                parent: this.filter.parent,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showFormDialog = true;          
            this.$nextTick(() => {
                this.$refs['regionForm'].clearValidate();
            });
        },
        handleEdit(region){

            let regionType = this.getAdministrativeRegion(region.path);

            this.dialogStatus = 'edit';
            this.showFormDialog = true;   
            this.regionForm.id = region.id;
            this.regionType = regionType;
            this.regionForm.name = region.name;
            this.regionForm.archived = region.archived;

            if(regionType == 'Provinsi'){                
                this.getProvinces();
                this.regionForm.province = region.id;
            }else if(regionType == 'Kabupaten/Kota'){                
                this.getProvinces();
                this.regionForm.province = region.parents.id;
                this.handleProvinceChange();
                this.regionForm.city = region.id;
            }else if(regionType == 'Kecamatan'){                
                this.getProvinces();
                this.regionForm.province = region.parents.parents.id;
                this.handleProvinceChange();
                this.regionForm.city = region.parents.id;
                this.handleCityChange();
                this.regionForm.district = region.id;
            }else if(regionType == 'Kelurahan'){                
                this.getProvinces();
                this.regionForm.province = region.parents.parents.parents.id;
                this.handleProvinceChange();
                this.regionForm.city = region.parents.parents.id;
                this.handleCityChange();
                this.regionForm.district = region.parents.id;
                this.handleDistrictChange();
                this.regionForm.subdistrict = region.id;
                this.regionForm.postal = region.postal;  
            }
            
            this.$nextTick(() => {
                this.$refs['regionForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.regionForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'region/addRegion';
                        payload = {
                            name: this.regionForm.name,
                            postal: this.regionForm.postal
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'region/editRegion';
                        payload = {
                            id: this.regionForm.id,
                            name: this.regionForm.name,
                            postal: this.regionForm.postal,
                            archived: this.regionForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showFormDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(region){
            this.$confirm('Anda mencoba untuk menghapus data wilayah, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('region/deleteRegion', {
                    id: region.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showFormDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.regionForm = {
                id: null,
                name: '',
                province: null,
                city: null,
                district: null,
                subdistrict: null,
                postal: ''
            }
        },
        handleProvinceChange(){
            this.regionForm.city = null;
            this.regionForm.district = null;
            this.regionForm.subdistrict = null;
            this.regionForm.postal = null;
            this.getCities();
            this.regionType = 'Kab/Kota';
        },
        handleCityChange() {
            this.regionForm.district = null;
            this.regionForm.subdistrict = null;
            this.regionForm.postal = null;
            this.getDistricts();
            this.regionType = 'Kecamatan';
        },
        handleDistrictChange() {
            this.regionForm.subdistrict = null;
            this.regionForm.postal = null;
            this.getSubdistricts();
            this.regionType = 'Kelurahan';
        },
        handleSubdistrictChange() {
            this.regionForm.postal = null;
            for( let i = 0; i < this.subdistricts.length; i++){
                if(this.subdistricts[i].id == this.regionForm.subdistrict){
                    this.regionForm.postal = this.subdistricts[i].postal;
                    break;
                }
            }
        }
    }

}
</script>
